import { Contexts, ContextReference, MappedActions, Middleware, InitActions, Meta } from './types';
/**
 * @hidden Internal function to map action creators to store actions
 */
export declare function mapActionsToDispatch<TState, TContexts extends Contexts, TMeta extends Meta, TInitActions extends InitActions<TState, TContexts, TMeta>>(contextReference: ContextReference<TState, TContexts, TMeta>, actions?: TInitActions, middleware?: Middleware[]): MappedActions<TState, TContexts, TMeta, TInitActions>;
/**
 * @hidden Internal function to map action creators to store actions when there are no Providers available
 */
export declare function mapActionsToDefault<TState, TContexts extends Contexts, TMeta extends Meta, TInitActions extends InitActions<TState, TContexts, TMeta>>(initialState: TState, meta: TMeta, actions?: TInitActions): MappedActions<TState, TContexts, TMeta, TInitActions>;
