import { Middleware, Contexts, InitActions, RetType, MiddlewareCreator, InitMiddleware, MiddlewareMeta, Meta } from './types';
/**
 * Helper method to create custom middleware. It makes possible to create middleware using user stores, so that it could call other actions.
 */
export declare function createMiddleware<TContexts extends Contexts>(initMiddleware: InitMiddleware<TContexts>, contexts?: TContexts): MiddlewareCreator<TContexts>;
/**
 * @hidden Internal method which runs an action with all the provided middleware
 */
export declare function runWithMiddleware<TState, TContexts extends Contexts, TArgs extends [], TReturn, TMiddleware extends Middleware<TArgs, TReturn>>(middleware: TMiddleware[], actions: RetType<InitActions<TState, TContexts, Meta>>, args: TArgs, meta: MiddlewareMeta): TReturn | Promise<TReturn>;
